"use strict";

angular.module("qpdelish.controllers", []), angular.module("qpdelish.directives", []), 
angular.module("qpdelish.filters", []), angular.module("qpdelish", [ "ionic", "ngAnimate", "ngResource", "ngSanitize", "LocalStorageModule", "ngCordova.plugins.dialogs", "ngCordova.plugins.ga", "ngCordova.plugins.barcodeScanner", "ngCordova.plugins.localNotification", "ngCordova.plugins.splashscreen", "ngCordova.plugins.statusbar", "qpdelish.controllers", "qpdelish.directives", "qpdelish.filters", "qpdelish.Dialog", "qpdelish.AppConfig", "qpdelish.User", "qpdelish.Offers", "qpdelish.Redeemed", "ngIOS9UIWebViewPatch" ]), 
angular.module("qpdelish").config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $locationProvider) {
    $ionicConfigProvider.views.transition("none");
}), angular.module("qpdelish").run(function($rootScope, $state, $ionicPlatform, $cordovaSplashscreen, $cordovaGA, AppConfig, $location, $http, $templateCache, Offers, $cordovaStatusbar, Dialog) {
    $rootScope.$on("$stateChangeSuccess", function(event, toState, toParams, fromState) {
        $state.previous = fromState;
    }), $http.get("templates/welcome.html", {
        cache: $templateCache
    }), $http.get("templates/terms-and-conditions.html", {
        cache: $templateCache
    }), $http.get("templates/first-run-help.html", {
        cache: $templateCache
    }), $http.get("templates/menu.html", {
        cache: $templateCache
    }), $http.get("templates/home.html", {
        cache: $templateCache
    }), $http.get("templates/help.html", {
        cache: $templateCache
    }), $http.get("templates/settings.html", {
        cache: $templateCache
    }), $http.get("templates/no-offers.html", {
        cache: $templateCache
    }), console.log("preloaded templates"), $ionicPlatform.ready(function() {
        console.log("preloaded templates 2 - ready"), ionic.Platform.isWebView() && (console.log("preloaded templates 3 - isWebView"), 
        $cordovaGA.init(AppConfig.analyticsId), $rootScope.$on("$stateChangeSuccess", function(event) {
            var promise = $cordovaGA.trackPage(function() {}, function() {}, $location.path());
            promise.then(function(result) {
                console.log("Analytics Success", $location.path(), result);
            }, function(error) {
                console.log("Analytics Error", $location.path(), error);
            });
        }), window.cordova && window.cordova.plugins.Keyboard && cordova.plugins.Keyboard.disableScroll(!0), 
        ionic.Platform.isIOS() && (console.log("preloaded templates 4 - isIOS"), $cordovaStatusbar.show(), 
        $cordovaStatusbar.style(0), $cordovaStatusbar.overlaysWebView(!0)));
    });
}), angular.module("qpdelish").config(function($stateProvider, $urlRouterProvider) {
    $stateProvider.state("welcome", {
        url: "/welcome",
        templateUrl: "templates/welcome.html",
        controller: "WelcomeCtrl"
    }).state("terms-and-conditions", {
        url: "/terms-and-conditions",
        templateUrl: "templates/terms-and-conditions.html",
        controller: "ContentCtrl"
    }).state("first-run-help", {
        url: "/first-run-help",
        templateUrl: "templates/first-run-help.html",
        controller: "HelpCtrl"
    }).state("no-offers", {
        url: "/no-offers",
        templateUrl: "templates/no-offers.html",
        controller: "NoOffersCtrl"
    }).state("app", {
        url: "/app",
        "abstract": !0,
        templateUrl: "templates/menu.html",
        controller: "MenuCtrl"
    }).state("app.home", {
        url: "/home/:categoryId",
        views: {
            menuContent: {
                templateUrl: "templates/home.html",
                controller: "HomeCtrl"
            }
        }
    }).state("app.help", {
        url: "/help/",
        views: {
            menuContent: {
                templateUrl: "templates/help.html",
                controller: "HelpCtrl"
            }
        }
    }).state("app.settings", {
        url: "/settings/",
        views: {
            menuContent: {
                templateUrl: "templates/settings.html",
                controller: "SettingsCtrl"
            }
        }
    }).state("app.terms-and-conditions", {
        url: "/terms-and-conditions/",
        views: {
            menuContent: {
                templateUrl: "templates/terms-and-conditions.html",
                controller: "ContentCtrl"
            }
        }
    }).state("app.category", {
        url: "/category",
        views: {
            menuContent: {
                templateUrl: "templates/category.html",
                controller: "CategoryCtrl"
            }
        }
    }), $urlRouterProvider.otherwise("/welcome");
}), angular.module("qpdelish.controllers").controller("CategoryCtrl", function($scope, $state, $window, Categories) {
    $scope.categories = Categories.query(), $scope.select = function(category) {
        $state.go("app.home", {
            categoryId: category.id
        });
    };
}), angular.module("qpdelish.controllers").controller("ContentCtrl", [ "$scope", "$state", "$ionicNavBarDelegate", "$ionicSideMenuDelegate", "$window", function($scope, $state, $ionicNavBarDelegate, $ionicSideMenuDelegate, $window) {
    $scope.$on("$ionicView.beforeEnter", function() {
        $scope.back = function() {
            $window.history.back();
        }, $scope.menu = function() {
            $ionicSideMenuDelegate.toggleLeft();
        }, $scope.backOrMenu = $state.previous && "welcome" == $state.previous.name, $scope.backOrMenu ? $ionicSideMenuDelegate.canDragContent(!1) : $ionicSideMenuDelegate.canDragContent(!0);
    });
} ]), angular.module("qpdelish.controllers").controller("HelpCtrl", function($scope, $state, $window, $ionicSlideBoxDelegate, $ionicSideMenuDelegate) {
    $scope.$on("$ionicView.beforeEnter", function() {
        $scope.activeSlide = 0, $ionicSideMenuDelegate.canDragContent(!0);
    });
    var slider = $ionicSlideBoxDelegate.$getByHandle("first-run-help-slider");
    $scope.move = function(index) {
        slider.slide(index);
    }, $scope.next = function() {
        return slider.currentIndex() >= 3 ? void $state.go("app.home") : void slider.next();
    }, $scope.prev = function() {
        slider.previous();
    }, $scope.slideChanged = function(index) {
        4 == index && $state.go("app.home");
    }, $scope.back = function() {
        $window.history.back();
    };
}), angular.module("qpdelish.controllers").controller("HomeCtrl", function($scope, $window, $state, $stateParams, $sce, $ionicSideMenuDelegate, $cordovaLocalNotification, $ionicPlatform, $cordovaBarcodeScanner, User, Offers, Dialog, Redeemed, $cordovaSplashscreen, AppConfig, Categories, $timeout) {
    $scope.$on("$ionicView.beforeEnter", function() {
        return $scope.categoryId = parseInt($stateParams.categoryId), User.isRegistered() ? ($scope.categoryId || $state.go("app.category"), 
        $ionicSideMenuDelegate.canDragContent(!0), $scope.offers = Offers.query(), $scope.$sce = $sce, 
        $scope.Redeemed = Redeemed, void ($window.Offers = Offers)) : void $state.go("welcome", {
            location: "replace"
        });
    }), $scope.random = function() {
        return .5 - Math.random();
    }, $scope.redeem = function(offer) {
        Dialog.confirm("QR Code scanner", "Please scan the QR Code at the counter", function(val) {
            1 == val && $scope.scan(offer);
        });
    }, $scope.filterByCategory = function(element) {
        return Redeemed.isFree() ? element.categoryId === Redeemed.categoryId : element.categoryId === $scope.categoryId;
    }, $scope.scan = function(offer) {
        var onError = function() {
            Dialog.alert("Could not scan QR Code, Please try again");
        }, onSuccess = function(result) {
            if (result.cancelled) return void Dialog.alert("Cancelled");
            if (!result.text || "" == result.text) return Dialog.alert("No Code"), void onError();
            if ("QR_CODE" != result.format) return Dialog.alert("The code scanned was not a valid QR code"), 
            void onError();
            var Redeemed = window.Redeemed;
            offer && offer.code == result.text || "local" === AppConfig.env ? (Redeemed.redeem(offer), 
            Redeemed.limitRedeemed && Redeemed.alreadyRedeemed && "dist" === AppConfig.env ? Dialog.alert("Already redeemed today", "You have already redeemed your lunch for today. See you tomorrow!") : Redeemed.isFree() ? (ionic.Platform.isWebView() && $cordovaLocalNotification.add({
                message: "Enjoy a free lunch!",
                badge: 1,
                autoCancel: !0
            }), Dialog.alert("Thanks and bon appetit!", "Your next lunch is free!")) : (ionic.Platform.isWebView() && $cordovaLocalNotification.cancelAll(), 
            Redeemed.freeMeal ? 0 == Redeemed.count ? Dialog.alert("Thanks and bon appetit!", "Enjoy your free lunch, See you tomorrow!") : Dialog.alert("Thanks and bon appetit!", "Only " + (Redeemed.required - Redeemed.count) + " to go until your free lunch. See you tomorrow!") : Dialog.alert("Thanks and bon appetit!"))) : Dialog.alert("The QR code did not match the selected deal.", "Please try again.");
        };
        if ($ionicPlatform.is("cordova")) {
            var promise = $cordovaBarcodeScanner.scan();
            promise.then(onSuccess), promise["catch"](function(error) {
                onError();
            });
        } else onSuccess({
            format: "QR_CODE",
            text: "qp-delish-oporto-deal-20140715"
        });
    }, $ionicPlatform.ready(function() {
        navigator.splashscreen && $timeout(function() {
            $cordovaSplashscreen.hide();
        }, 2e3);
    });
}), angular.module("qpdelish.controllers").controller("MenuCtrl", function($scope, $state, Offers) {
    $scope.$on("$ionicView.beforeEnter", function() {
        Offers.isPromoPeriod() || $state.go("no-offers", {
            location: "replace"
        });
    });
}), angular.module("qpdelish.controllers").controller("NoOffersCtrl", [ "$scope", "$state", "$cordovaSplashscreen", "$ionicPlatform", "$timeout", "Offers", function($scope, $state, $cordovaSplashscreen, $ionicPlatform, $timeout, Offers) {
    console.log("NoOffersController"), Offers.isPromoPeriod() && (console.log("Is promo - go to welcome"), 
    $state.go("welcome", {
        location: "replace"
    })), $ionicPlatform.ready(function() {
        console.log("NoOffersController 2 - ready"), navigator.splashscreen && (console.log("NoOffersController 3 - is splashscreen"), 
        $timeout(function() {
            $cordovaSplashscreen.hide(), console.log("splash called");
        }, 2e3));
    });
} ]), angular.module("qpdelish.controllers").controller("SettingsCtrl", [ "$scope", "User", "$window", "$ionicSideMenuDelegate", function($scope, User, $window, $ionicSideMenuDelegate) {
    $scope.User = User, $ionicSideMenuDelegate.canDragContent(!1), $scope.save = function() {
        $scope.User.save();
        $ionicSideMenuDelegate.toggleLeft();
    };
} ]), angular.module("qpdelish.controllers").controller("WelcomeCtrl", [ "$scope", "$state", "$timeout", "$ionicNavBarDelegate", "User", "Dialog", "Offers", "$cordovaSplashscreen", "$ionicPlatform", function($scope, $state, $timeout, $ionicNavBarDelegate, User, Dialog, Offers, $cordovaSplashscreen, $ionicPlatform) {
    return console.log("Welcome"), User.isRegistered() ? void $state.go("app.home", {
        location: "replace"
    }) : (console.log("$ionicNavBarDelegate.showBar(false)", $ionicNavBarDelegate.showBar()), 
    $scope.loading = !1, $scope.User = User, $scope.save = function(form) {
        if (form.$invalid) return Dialog.alert("Sign up.", "Please accept the Terms and Conditions before continuing.");
        $scope.loading = !0;
        var promise = $scope.User.save();
        promise.then($scope.success)["catch"]($scope.fail)["finally"](function() {
            $scope.loading = !1;
        });
    }, $scope.success = function(response) {
        Dialog.confirm("Thanks for signing up to QP Delish.", "Press HELP to find out how it all works, or press HOME to start redeeming.", function(val) {
            $timeout(function() {
                1 == val ? $state.go("first-run-help", {
                    location: "replace"
                }) : $state.go("app.home", {
                    location: "replace"
                });
            });
        }, [ "HELP", "HOME" ]);
    }, $scope.fail = function(request) {
        console.log("user save failed", request), Dialog.alert("Pardon moi,", "There seems to be a problem. Please wait a few moments and try again.");
    }, void $ionicPlatform.ready(function() {
        navigator.splashscreen && $timeout(function() {
            $cordovaSplashscreen.hide();
        }, 2e3);
    }));
} ]), angular.module("qpdelish.directives").directive("inputDatePlaceholder", [ "$window", "$timeout", function($window, $timeout) {
    return {
        link: function(scope, element, attrs) {
            console.log("inputDatePlaceholder directive link()");
            var placeholderText, placeholderElem;
            placeholderText = element.attr("placeholder"), placeholderElem = angular.element('<input type="text" class="topcoat-text-input placeholder" />'), 
            element.parent().prepend(placeholderElem.attr("placeholder", placeholderText));
            var hidePlaceholder = function(focus) {
                console.log("hidePlaceholder", element.val()), placeholderElem.css({
                    visibility: "hidden"
                });
            }, showPlaceholder = function() {
                var value = element.val();
                console.log("showPlaceholder", value), placeholderElem.css({
                    visibility: "visible"
                });
            }, updatePlaceholder = function() {
                var value = element.val();
                value ? hidePlaceholder(!1) : showPlaceholder();
            };
            element.on("focus", function() {
                hidePlaceholder(!0);
            }), element.on("blur", function() {
                console.log("element blurred"), element.val() || showPlaceholder();
            }), console.log("Supports Month: ", $window.Modernizr.inputtypes.month), $window.Modernizr && $window.Modernizr.inputtypes.month || element.on("focus", function() {
                console.log("Native month focus state triggered!");
                var options = {
                    date: new Date(),
                    mode: "date",
                    allowOldDates: !0,
                    allowFutureDates: !1
                };
                $window.datePicker.show(options, function(value) {
                    var valueDate = new Date(value), valueFormat = valueDate.toISOString().slice(0, 10);
                    element.val(valueFormat), element[0].blur();
                }), element[0].blur();
            }), scope.$watch(attrs.value, function(value) {
                updatePlaceholder();
            });
        }
    };
} ]), angular.module("qpdelish.filters").filter("newline", function() {
    return function(text) {
        return text.replace(/\n/g, "<br/>");
    };
}), angular.module("ngIOS9UIWebViewPatch", [ "ng" ]).config(function($provide) {
    $provide.decorator("$browser", [ "$delegate", "$window", function($delegate, $window) {
        function isIOS9UIWebView(userAgent) {
            return /(iPhone|iPad|iPod).* OS 9_\d/.test(userAgent) && !/Version\/9\./.test(userAgent);
        }
        function applyIOS9Shim(browser) {
            function clearPendingLocationUrl() {
                pendingLocationUrl = null;
            }
            var pendingLocationUrl = null, originalUrlFn = browser.url;
            return browser.url = function() {
                return arguments.length ? (pendingLocationUrl = arguments[0], originalUrlFn.apply(browser, arguments)) : pendingLocationUrl || originalUrlFn.apply(browser, arguments);
            }, window.addEventListener("popstate", clearPendingLocationUrl, !1), window.addEventListener("hashchange", clearPendingLocationUrl, !1), 
            browser;
        }
        return isIOS9UIWebView($window.navigator.userAgent) ? applyIOS9Shim($delegate) : $delegate;
    } ]);
}), angular.module("qpdelish.AppConfig", []).factory("AppConfig", [ "$rootScope", function($rootScope) {
    var service = {
        analyticsId: "UA-48631166-14",
        env: "dist"
    };
    return service;
} ]), angular.module("qpdelish.Dialog", [ "ngCordova.plugins.dialogs" ]).factory("Dialog", [ "$ionicPlatform", "$cordovaDialogs", function($ionicPlatform, $cordovaDialogs) {
    return {
        alert: function(title, message, alertCallback, buttonName) {
            return alertCallback && "function" == typeof alertCallback || (alertCallback = function() {
                return !0;
            }), null == title && (title = ""), null == message && (message = ""), ionic.Platform.isWebView() ? $cordovaDialogs.alert(message, title, buttonName).then(alertCallback) : (title && (message = title + " " + message), 
            alert(message), alertCallback());
        },
        confirm: function(title, message, confirmCallback, buttonLabels) {
            return confirmCallback && "function" == typeof confirmCallback || (confirmCallback = function() {
                return !0;
            }), null == title && (title = ""), null == message && (message = ""), ionic.Platform.isWebView() ? $cordovaDialogs.confirm(message, title, buttonLabels).then(confirmCallback) : confirmCallback(confirm(message) ? 1 : 2);
        }
    };
} ]), function() {
    var categories = [ {
        id: 1,
        title: "Petit Picks",
        pricePoint: 5,
        description: "A little something faboulus for your taste buds",
        sort: 1
    }, {
        id: 2,
        title: "Chic Eats",
        pricePoint: 6,
        description: "Upgrade to something more spohisticated",
        sort: 2
    }, {
        id: 3,
        title: "Ooh la la",
        pricePoint: 8,
        description: "Welcome to the super luxe range",
        sort: 3
    } ], items = [ {
        id: 1,
        vendor: "Chatime",
        title: "Regular Drink",
        conditions: "",
        code: "QP Delish October 2015 Chatime",
        sort: .5 - Math.random(),
        categoryId: 1
    }, {
        id: 2,
        vendor: "Healthy Habits",
        title: "Regular HotBeverage withany Miss BlissProtein Ball orMonster Cookie",
        conditions: "",
        code: "QP Delish October 2015 Healthy Habits",
        sort: .5 - Math.random(),
        categoryId: 1
    }, {
        id: 3,
        vendor: "Oporto",
        title: "ChickenRappsnacker + Small Chips +Can of Drink",
        conditions: "",
        code: "QP Delish October 2015 Oporto",
        sort: .5 - Math.random(),
        categoryId: 1
    }, {
        id: 4,
        vendor: "Suncrane",
        title: "Any twoSushi Rolls +Cup ofMiso Soup",
        conditions: "",
        code: "QP Delish October 2015 Suncrane",
        sort: .5 - Math.random(),
        categoryId: 1
    }, {
        id: 5,
        vendor: "Burger Edge",
        title: "Original Edge Burger (White orWholemeal Bun)",
        conditions: "No alterations",
        code: "QP Delish October 2015 Burger Edge",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 6,
        vendor: "Chatime",
        title: "Regular Drink + One NutRoasters Pack",
        conditions: "",
        code: "QP Delish October 2015 Chatime",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 7,
        vendor: "Healthy Habits",
        title: "Regular HotBeverage with Value Rollor Half Wrap",
        conditions: "",
        code: "QP Delish October 2015 Healthy Habits",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 8,
        vendor: "Mad Mex",
        title: "Small Burrito(extras notincluded)",
        conditions: "",
        code: "QP Delish October 2015 Mad Mex",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 9,
        vendor: "Michel's Patisserie",
        title: "Large Pie &600ml Water",
        conditions: "",
        code: "QP Delish October 2015 Michel's Patisserie",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 10,
        vendor: "New Shanghai",
        title: "Xiao Long Bao – Steamed Pork Dumplings (8pcs)",
        conditions: "",
        code: "QP Delish October 2015 New Shanghai",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 11,
        vendor: "Oporto",
        title: "Steak Rappsnacker + Small Chips+ Can of Drink",
        conditions: "",
        code: "QP Delish October 2015 Oporto",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 12,
        vendor: "Red Rooster",
        title: "Classic Burger, Small Chips& Regular Gravy",
        conditions: "",
        code: "QP Delish October 2015 Red Rooster",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 13,
        vendor: "Snag Stand",
        title: "American ClassicHaute Dog",
        conditions: "",
        code: "QP Delish October 2015 Snag Stand",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 14,
        vendor: "Soul Origin",
        title: "Small Coffee with any Muffin, Cookie or Banana Bread",
        conditions: "",
        code: "QP Delish October 2015 Soul Origin",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 15,
        vendor: "Suncrane",
        title: "Regular Chicken Karage + Rice + Cup of Miso Soup",
        conditions: "",
        code: "QP Delish October 2015 Suncrane",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 16,
        vendor: "Boost Juice",
        title: "Original Smoothie(low fat range) orOriginal Dairy Free Crush plus Banana Bread & 600ml Mt Franklin Water.",
        conditions: "",
        code: "QP Delish October 2015 Boost Juice",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 17,
        vendor: "Chatime",
        title: "Two RegularDrinks",
        conditions: "",
        code: "QP Delish October 2015 Chatime",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 18,
        vendor: "Healthy Habits",
        title: "Half Wrap or Value Roll with one Cup of Fruit Salad + Bottle of Water",
        conditions: "",
        code: "QP Delish October 2015 Healthy Habits",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 19,
        vendor: "Michel's Patisserie",
        title: "Large Spinach Roll + Small Coffee",
        conditions: "",
        code: "QP Delish October 2015 Michel's Patisserie",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 20,
        vendor: "Michel's Patisserie",
        title: "Large Sausage Roll + Small Coffee",
        conditions: "",
        code: "QP Delish October 2015 Michel's Patisserie",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 21,
        vendor: "New Shanghai",
        title: "Pan Fried Pork Buns (8pcs)",
        conditions: "",
        code: "QP Delish October 2015 New Shanghai",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 22,
        vendor: "Oporto",
        title: "Single Bondi Burger + Small Chips + Can of Drink",
        conditions: "",
        code: "QP Delish October 2015 Oporto",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 23,
        vendor: "Red Rooster",
        title: "Rooster Roll,Small Chips &Regular Gravy",
        conditions: "",
        code: "QP Delish October 2015 Red Rooster",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 24,
        vendor: "Roll'd",
        title: '"The B" Bowl& Iced Tea',
        conditions: "",
        code: "QP Delish October 2015 Roll'd",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 25,
        vendor: "Snag Stand",
        title: "Stand Burger",
        conditions: "",
        code: "QP Delish October 2015 Snag Stand",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 26,
        vendor: "Suncrane",
        title: "Regular Teriyaki Chicken +Cup of Miso Soup",
        conditions: "",
        code: "QP Delish October 2015 Suncrane",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 27,
        vendor: "Boost Juice",
        title: "$1 Mt Franklin Water 600ml",
        conditions: "",
        bonus: !0,
        code: "QP Delish October 2015 Boost Juice",
        sort: .5 - Math.random(),
        categoryId: 1
    }, {
        id: 28,
        vendor: "Chatime",
        title: "NutRoastersPack",
        conditions: "",
        bonus: !0,
        code: "QP Delish October 2015 Chatime",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 29,
        vendor: "Mad Mex",
        title: "Churros& Chocolate",
        conditions: "",
        bonus: !0,
        code: "QP Delish October 2015 Mad Mex",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 30,
        vendor: "Michel's Patisserie",
        title: "Brownie",
        conditions: "",
        bonus: !0,
        code: "QP Delish October 2015 Michel's Patisserie",
        sort: .5 - Math.random(),
        categoryId: 2
    }, {
        id: 31,
        vendor: "Oporto",
        title: "Large Chips",
        conditions: "",
        bonus: !0,
        code: "QP Delish October 2015 Oporto",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 32,
        vendor: "Red Rooster",
        title: "ThreeChicken Wings",
        conditions: "",
        bonus: !0,
        code: "QP Delish October 2015 Red Rooster",
        sort: .5 - Math.random(),
        categoryId: 3
    }, {
        id: 33,
        vendor: "Roll'd",
        title: "TwoRoll’d Soldiers",
        conditions: "",
        bonus: !0,
        code: "QP Delish October 2015 Roll'd",
        sort: .5 - Math.random(),
        categoryId: 3
    } ], findById = function(id) {
        items || (items = window.offers);
        var i, item = null, l = items.length;
        for (i = 0; l > i; i++) if (items[i].id === id) {
            item = items[i];
            break;
        }
        return item;
    };
    window.offers = items, angular.module("qpdelish.Offers", []).factory("Offers", [ "AppConfig", function(AppConfig) {
        var service = {
            query: function() {
                return service.isPromoPeriod() ? items : [];
            },
            get: function(id) {
                return findById(parseInt(id));
            },
            isPromoPeriod: function() {
                console.log("isPromoPeriod?");
                var now = Date.now(), endDate = new Date(2015, 10, 1, 23, 0).getTime(), result = endDate >= now;
                return console.log("isPromoPeriod? 2", result), "dist" !== AppConfig.env ? !0 : result;
            }
        };
        return service;
    } ]).factory("Categories", function() {
        var service = {
            query: function() {
                return categories;
            },
            getById: function(id) {
                var selectedCategory = null;
                return angular.forEach(categories, function(category, key) {
                    category.id === parseInt(id) && (selectedCategory = category);
                }), selectedCategory;
            }
        };
        return service;
    });
}(), angular.module("qpdelish.Redeemed", [ "LocalStorageModule" ]).factory("Redeemed", [ "$rootScope", "$window", "localStorageService", "$resource", "$filter", "User", "Categories", "$cordovaGA", "$ionicPlatform", "AppConfig", function($rootScope, $window, localStorageService, $resource, $filter, User, Categories, $cordovaGA, $ionicPlatform, AppConfig) {
    var service = (Categories.query(), {
        resource: $resource("http://qpdelish.cruprojects.com.au/api/redeem", {}),
        models: [],
        count: 0,
        total: 0,
        required: 7,
        freeMeal: !1,
        categoryId: null,
        last: null,
        alreadyRedeemed: !1,
        limitRedeemed: !1,
        load: function() {
            var val = localStorageService.get("Redeemed"), models = localStorageService.get("RedeemedOffers");
            return service.categoryId = localStorageService.get("categoryId"), service.last = localStorageService.get("last"), 
            val && val.count && (service.count = val.count), val && val.total && (service.total = val.total), 
            angular.isArray(models) || (service.models = []), console.log("loaded redeemed offers", val, models), 
            this;
        },
        saveLocal: function() {
            localStorageService.set("Redeemed", {
                count: service.count,
                total: service.total
            }), localStorageService.set("RedeemedOffers", service.models), localStorageService.set("categoryId", service.categoryId);
        },
        saveRemote: function() {
            console.log("start saveRemote");
            var unsynced = service.unsynced(), data = {
                key: User.model.key,
                redeems: unsynced
            };
            console.log("sending saveRemote", unsynced), this.resource.save(data, function(response) {
                angular.forEach(unsynced, function(value, key) {
                    unsynced[key].created_at = Date.now();
                }), service.saveLocal();
            }, function(response) {
                console.log("Redeem.saveRemote failed", response);
            }), console.log("end saveRemote");
        },
        updateLatest: function(last) {
            service.last = last, localStorageService.set("last", service.last);
        },
        increment: function() {
            service.count++, service.total++, service.count > service.required && (service.count = 0, 
            service.categoryId = null), service.saveLocal(), service.saveRemote();
        },
        isFree: function() {
            return service.freeMeal ? service.count == service.required : !1;
        },
        redeem: function(offer) {
            var category = Categories.getById(offer.categoryId), categoryTxt = category.title + " " + category.pricePoint + " AUD", today = new Date(Date.now()).getDate(), last = service.last;
            if (service.last && (last = service.last), last && last == today && "dist" === AppConfig.env) service.alreadyRedeemed = !0; else {
                var redeemed = {
                    code: offer.code,
                    redeemed_at: Date.now(),
                    created_at: null,
                    free: service.isFree(),
                    key: User.model.key,
                    count: service.count + 1
                };
                ionic.Platform.isWebView() && (service.isFree() ? $cordovaGA.trackEvent("Redeem", "Free Lunch", offer.code, service.count + 1) : $cordovaGA.trackEvent("Redeem", categoryTxt, offer.code, service.count + 1)), 
                service.updateLatest(today), service.alreadyRedeemed = !1, console.log("cat pricePoint ", category.id), 
                (!service.categoryId || category.pricePoint < Categories.getById(service.categoryId).pricePoint) && (service.categoryId = category.id, 
                console.log("pricePoint yeah", service.id));
            }
            service.models.push(redeemed), service.increment();
        },
        unsynced: function() {
            return $filter("filter")(service.models, {
                created_at: null
            });
        }
    });
    return service.load(), $window.Redeemed = service, service;
} ]), angular.module("qpdelish.User", [ "LocalStorageModule" ]).factory("User", [ "$rootScope", "localStorageService", "$resource", "$ionicPlatform", function($rootScope, localStorageService, $resource, $ionicPlatform) {
    var UserResource = $resource("http://qpdelish.cruprojects.com.au/api/user", {}), service = {
        resource: new UserResource(),
        model: {
            key: !1,
            name: "",
            birthday: "",
            email: "",
            terms: !1,
            push: !0,
            communications: !0,
            tracking: !0,
            platform: null,
            model: null,
            version: null,
            udid: null
        },
        save: function() {
            return console.log("Saving User", service.model), service.saveLocal(), this.saveRemote();
        },
        saveLocal: function() {
            localStorageService.set("User", service.model);
        },
        saveRemote: function() {
            angular.extend(service.resource, service.model);
            var promise = service.resource.$save();
            return promise.then(function(response) {
                console.log("response", response), response.key && (service.model.key = response.key, 
                service.saveLocal());
            }), promise;
        },
        load: function() {
            var attrs = localStorageService.get("User");
            return console.log("Loading User", attrs), angular.isObject(attrs) && angular.extend(service.model, attrs), 
            this;
        },
        isRegistered: function() {
            return service.model.key;
        }
    };
    return service.load(), $ionicPlatform.ready(function() {}), service;
} ]);